#include "btHACDCompoundShape.h"
// I just need this method in HACDDemo.cpp:
bool LoadHACDCompoundShapeParams(char* paramsFilePath,btHACDCompoundShape::Params& params,bool* extraParamUseAutoGeneratedSaveNameToSaveShape=NULL,bool* extraParamInvertYZ=NULL,bool* extraParamIgnoreAllParamsAndCreateBvhTriangleMeshShape=NULL,bool* extraParamIgnoreAllParamsAndCreateGImpaceMeshShape=NULL);


// IMPLEMENTATION:





#include <stdlib.h>
#include <iostream>
#include <fstream>

#ifndef USE_STRING_CONVERSION_MODE_NUMBER
#define USE_STRING_CONVERSION_MODE_NUMBER 2	// in [1,3] (3 is the best, but needs <boost/lexical_cast.hpp>, 2 is the second best choice)
#endif //USE_STRING_CONVERSION_MODE_NUMBER

#if (USE_STRING_CONVERSION_MODE_NUMBER==2)
#include <sstream>
#elif  (USE_STRING_CONVERSION_MODE_NUMBER==3)
#include <boost/lexical_cast.hpp>	// Just 2 lines of code use it... TODO: find replecement
#endif //USE_STRING_CONVERSION_MODE_NUMBER


class String {
public:
inline static std::vector<std::string> Split(const std::string& text,const char c=' ')	{
std::string tex(text);
std::vector<std::string> ret;
std::size_t beg=std::string::npos;
while ( (beg=tex.find_first_of(c))!=std::string::npos)
        {
        ret.push_back(tex.substr(0,beg));
        tex=tex.substr(beg+1);
        }
ret.push_back(tex);
return ret;
}
inline static std::string TrimStart(const std::string& text,const char c=' ')	{
std::string tex(text);
while (tex.size()>0 && tex[0]==c) tex=tex.substr(1);
return tex;
}
inline static std::string TrimEnd(const std::string& text,const char c=' '){
std::string tex(text);
while (tex.size()>0 && tex[tex.size()-1]==c) tex=tex.substr(0,tex.size()-1);
return tex;
}
inline static std::string Trim(const std::string& text,const char c=' ')	{
        return TrimStart(TrimEnd(text),c);
}
inline static std::string TrimStart(const std::string& text,const char c1,const char c2)	{
        std::string tex(text);
        char c;
        while (tex.size()>0)	{
                c = tex[0];
                if (c==c1 || c==c2) {tex=tex.substr(1);continue;}
                break;
         }
        return tex;
}
inline static std::string TrimEnd(const std::string& text,const char c1,const char c2)	{
        std::string tex(text);
        char c;
        while (tex.size()>0)	{
                c = tex[tex.size()-1];
                if (c==c1 || c==c2) {tex=tex.substr(0,tex.size()-1);continue;}
                break;
         }
        return tex;
}
inline static std::string Trim(const std::string& text,const char c1,const char c2)	{
        return TrimStart(TrimEnd(text,c1,c2),c1,c2);
}

inline static bool StartsWith(const std::string& text,const std::string& start){
unsigned long textLength=text.size();
unsigned long searchLength=start.size();
if (searchLength>textLength) return false;
for (int t=0;t<searchLength;t++)
        {
        if (start[t]!=text[t]) return false;
        }
return true;
}
inline static std::string Replace(const std::string&  baseText,const std::string& textToReplace,const std::string& replacement) {
std::string text(baseText);
if (textToReplace=="") return text;
std::size_t textToReplaceLength=textToReplace.size();
std::size_t i=std::string::npos;
while ( (i=text.find(textToReplace,0))!=std::string::npos )
        {
        text=text.substr(0,i)+replacement+text.substr(i+textToReplaceLength);
        }
return text;
}
inline static std::string ToLower(const std::string& text)	{
std::string ret(text);
for(int i=0;i<ret.length();++i) ret[i]=tolower(ret[i]);
return ret;
}
inline static std::string GetExtension(const std::string& filePath){
std::size_t beg=filePath.find_last_of('.');
if (beg!=std::string::npos)  return ToLower(filePath.substr(beg));
return "";
}
inline static bool FileExists(const std::string& filePath) {
        FILE * fid = fopen(filePath.c_str(), "r");
        if (!fid) return false;
        fclose(fid);
        return true;
}
inline static bool Break(const std::string& text,const char breaker,std::string& part0,std::string& part1,bool findFirst=true,int keepBreakerInPart=-1)	{
        part0=part1="";
        std::size_t beg=std::string::npos;
        if (findFirst) beg = text.find(breaker);
        else beg = text.find_last_of(breaker);
        if (beg==std::string::npos) return false;
        if (keepBreakerInPart == 0)	{
                part0 = text.substr(0,beg+1);
                part1 = text.substr(beg+1);
        }
        else if (keepBreakerInPart == 1)	{
                part0 = text.substr(0,beg);
                part1 = text.substr(beg);
        }
        else	{
                part0 = text.substr(0,beg);
                part1 = text.substr(beg+1);
        }
        return true;
}
inline static std::string Extract(const std::string& text,const char startChar,const char endChar,bool* optionalOperationSuccessfullFlag=NULL)	{
        std::string rv("");
        std::size_t beg=std::string::npos;
        beg = text.find(startChar);
        if (beg == std::string::npos) {
                if (optionalOperationSuccessfullFlag) *optionalOperationSuccessfullFlag = false;
                return rv;
        }
        std::size_t beg2=std::string::npos;
        beg2 = text.find(endChar,beg+1);
        if (beg2 == std::string::npos) {
                if (optionalOperationSuccessfullFlag) *optionalOperationSuccessfullFlag = false;
                return rv;
        }
        rv = text.substr(beg+1,beg2-(beg+1));
        if (optionalOperationSuccessfullFlag) *optionalOperationSuccessfullFlag = true;
        //printf("Line: \"%s\"\nExtracted: \"%s\"\n",text.c_str(),rv.c_str());
        return rv;
}

#if  (USE_STRING_CONVERSION_MODE_NUMBER==2 || USE_STRING_CONVERSION_MODE_NUMBER==3)
template < typename T > inline static T Convert(const std::string& text)	{
        #if  (USE_STRING_CONVERSION_MODE_NUMBER==2)
        static std::locale classicLocale(std::locale::classic());
        std::istringstream s(text);s.imbue(classicLocale);	// (some locales map the decimal separator with the comma, instead of with the dot).
    T t;
        s >> t;
        if (s.fail()) {
                #ifndef __GNUC__
        std::runtime_error e("Invalid string conversion of: "+text);
        throw e;
        #endif //__GNUC__
    }
        return t;
        #elif  (USE_STRING_CONVERSION_MODE_NUMBER==3)
        return boost::lexical_cast< T > (text);
        #endif //USE_STRING_CONVERSION_MODE_NUMBER
}
#endif //USE_STRING_CONVERSION_MODE_NUMBER

inline static int ConvertToInt(const std::string& text)	{
        #if (USE_STRING_CONVERSION_MODE_NUMBER==1)
        return atoi(text);
        #else //USE_STRING_CONVERSION_MODE_NUMBER
        return Convert< int >(text);
        #endif //USE_STRING_CONVERSION_MODE_NUMBER
}
inline static float ConvertToFloat(const std::string& text)	{
        #if (USE_STRING_CONVERSION_MODE_NUMBER==1)
        return atof(text);
        #else //USE_STRING_CONVERSION_MODE_NUMBER
        return Convert< float >(text);
        #endif //USE_STRING_CONVERSION_MODE_NUMBER
}

protected:
String() {}
};


static char charTab = 9;
template < typename T > static bool GetValueFromLine(const std::string& line,T& valueOut)	{
        std::string l,part0,part1;
        if (!String::Break(line,'=',part0,part1)) {
                return false;
        }
        l = String::TrimStart(part1,' ',charTab);
        if (!String::Break(l,';',part0,part1)) {
                return false;
        }
        l = part0;
        try {
                valueOut = String::Convert<T>(l);
        }
        catch (...)	{
                return false;
        }
        return true;
}
// can parse: " = true;" "something = false; //comment". Returns false in case of parsing errors
static bool GetBoolValueFromLine(const std::string& line,bool& valueOut)	{
        std::string l,part0,part1;
        if (!String::Break(line,'=',part0,part1)) return false;
        l = String::TrimStart(part1,' ',charTab);
        if (!String::Break(l,';',part0,part1)) return false;
        l = String::ToLower(String::TrimEnd(part0,' ',charTab));
        if (l == "true") 			valueOut = true;
        else if (l == "false")		valueOut = false;
        else {
                //printf("ERROR IN: GetBoolValueFromLine(\"%s\") while processing line:\n\"%s\".\n",l.c_str(),line.c_str());
                return false;
        }
        return true;
}
// can parse: " = 54;" "something = 35; //comment". Returns false in case of parsing errors
static bool GetIntValueFromLine(const std::string& line,int& valueOut)	{
        return GetValueFromLine< int >(line,valueOut);
}
// can parse: " = 54;" "something = 35; //comment". Returns false in case of parsing errors
static bool GetSizeTValueFromLine(const std::string& line,size_t& valueOut)	{
        return GetValueFromLine< size_t >(line,valueOut);
}
// can parse: " = 3.8;" "something = 2.7; //comment". Returns false in case of parsing errors
static bool GetFloatValueFromLine(const std::string& line,float& valueOut)	{
        return GetValueFromLine< float >(line,valueOut);
}
// can parse: " = 3.8;" "something = 2.7; //comment". Returns false in case of parsing errors
static bool GetDoubleValueFromLine(const std::string& line,double& valueOut)	{
        return GetValueFromLine< double >(line,valueOut);
}
// can parse: "btVector3(3.4,5.6,7.8);" "(2.3,3.4,4.5) //comment". Returns false in case of parsing errors
static bool GetBtVector3ValueFromLine(const std::string& line,btVector3& valueOut,bool checkForStartingEqualitySign = true,bool checkForEndingSemicolon = true)	{
        std::string l(line);
        std::string part0,part1;
        if (checkForStartingEqualitySign)	{
                if (!String::Break(line,'=',part0,part1)) return false;
                l = String::TrimStart(part1,' ',charTab);
        }
        if (checkForEndingSemicolon) {
                if (!String::Break(l,';',part0,part1)) return false;
                l = String::TrimEnd(part0,' ',charTab);
        }
        l = String::Extract(l,'(',')');
        std::vector < std::string > parts = String::Split(l,',');
        const size_t partsSize = parts.size();
        if (partsSize<3) return false;
        btVector3 temp(0,0,0);
        try	{
                temp.setX(String::ConvertToFloat(String::Trim(parts[0],' ',charTab)));
                temp.setY(String::ConvertToFloat(String::Trim(parts[1],' ',charTab)));
                temp.setZ(String::ConvertToFloat(String::Trim(parts[2],' ',charTab)));
        }
        catch(...)	{
                return false;
        }
        valueOut = temp;
        return true;
}
// can parse: "{1,2,3,4,5,6};" Returns false in case of parsing errors
static bool GetIntVectorValueFromLine(const std::string& line,btHACDCompoundShape::Params::IntVector& valueOut,bool checkForStartingEqualitySign = true,bool checkForEndingSemicolon = true)	{
        std::string l(line);
        std::string part0,part1;
        if (checkForStartingEqualitySign)	{
                if (!String::Break(line,'=',part0,part1)) return false;
                l = String::TrimStart(part1,' ',charTab);
        }
        if (checkForEndingSemicolon) {
                if (!String::Break(l,';',part0,part1)) return false;
                l = String::TrimEnd(part0,' ',charTab);
        }
        l = String::Extract(l,'{','}');
        std::vector < std::string > parts = String::Split(l,',');
        const size_t partsSize = parts.size();
        btAlignedObjectArray < int > temp;
        std::string t;
        for (size_t i=0;i<partsSize;i++)	{
                t = String::Trim(parts[i],' ',charTab);
                if (t.size()==0) continue;
                try	{
                        temp.push_back(String::ConvertToInt(t));
                }
                catch(...)	{
                        return false;
                }
        }
        valueOut.resize(0);
        valueOut.reserve(temp.size());
        for (int i=0;i<temp.size();i++) valueOut.push_back(temp[i]);
        return true;
}
// can parse: " = "myString;" "something = "myString"; //comment". Returns false in case of parsing errors
static bool GetStringValueFromLine(const std::string& line,std::string& valueOut)	{
        std::string l,part0,part1;
        if (!String::Break(line,'=',part0,part1)) return false;
        l = String::TrimStart(part1,' ',charTab);
        if (!String::Break(l,';',part0,part1)) return false;
        bool ok =false;
        l = String::Extract(String::TrimEnd(part0,' ',charTab),'\"','\"',&ok);
        if (!ok) return false;
        valueOut = l;
        return true;
}


bool LoadHACDCompoundShapeParams(char* paramsFilePath,btHACDCompoundShape::Params& params,bool* extraParamUseAutoGeneratedSaveNameToSaveShape,bool* extraParamInvertYZ,bool* extraParamIgnoreAllParamsAndCreateBvhTriangleMeshShape,bool* extraParamIgnoreAllParamsAndCreateGImpaceMeshShape,bool* extraParamDecomposeBCSInputFileIfShapeIsCompatible)	{
        if (extraParamUseAutoGeneratedSaveNameToSaveShape) *extraParamUseAutoGeneratedSaveNameToSaveShape=false;
        if (extraParamInvertYZ) *extraParamInvertYZ=false;
        if (extraParamIgnoreAllParamsAndCreateBvhTriangleMeshShape) *extraParamIgnoreAllParamsAndCreateBvhTriangleMeshShape=false;
        if (extraParamIgnoreAllParamsAndCreateGImpaceMeshShape) *extraParamIgnoreAllParamsAndCreateGImpaceMeshShape=false;
        if (extraParamDecomposeBCSInputFileIfShapeIsCompatible) *extraParamDecomposeBCSInputFileIfShapeIsCompatible=false;
        params.reset();
        std::string errorLines = "",part0,part1;
        std::ifstream in(paramsFilePath,std::ios::in);
        if (!in) return false;
        try {
                const char charTab = 9;
                bool mustExclude = false;
                std::string line="";std::string l = "";
                while (std::getline(in,line))	{
                        //printf("%s\n",line.c_str());
                         //region Parser
                        line = String::Trim(String::TrimEnd(line,'\n','\r'),' ',charTab);
                        if (mustExclude)	{
                                if (String::StartsWith(line,"*/")) {
                                        mustExclude = false;
                                        line = String::TrimStart(line.substr(2),' ',charTab);
                                }
                                else continue;
                        }
                        if (line.size()==0 || String::StartsWith(line,"//")) continue;
                        else if (String::StartsWith(line,"/*"))	{
                                mustExclude = true;
                                continue;
                        }

                        if (String::StartsWith(line,"params."))	{
                                l = line.substr(7);
                                 //region Params
                                if (String::StartsWith(l,"reset()")) {
                                        params.reset();
                                        continue;
                                }
                                else if (String::StartsWith(l,"resetForSpeed()")) {
                                        params.resetForSpeed();
                                        continue;
                                }
                                else if (String::StartsWith(l,"resetWithHACDDefaults()")) {
                               		    params.resetWithHACDDefaults();
                                        continue;
                                }
                                else if (String::StartsWith(l,"resetForCommonUsage()")) {
                               		    params.resetForCommonUsage();
                                        continue;
                                }
                                else if (String::StartsWith(l,"maxHullVertices"))	{
                                        if (!GetSizeTValueFromLine(l,params.maxHullVertices)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"concavity"))	{
                                        if (!GetDoubleValueFromLine(l,params.concavity)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"nClusters"))	{
                                        if (!GetSizeTValueFromLine(l,params.nClusters)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"addExtraDistPoints"))	{
                                        if (!GetBoolValueFromLine(l,params.addExtraDistPoints)) errorLines+=line+"\n";
                                        continue;
                                }
                                /*
                                else if (String::StartsWith(l,"addNeighboursDistPoints"))	{
                                        if (!GetBoolValueFromLine(l,params.addNeighboursDistPoints)) errorLines+=line+"\n";
                                        continue;
                                }
                                */
                                else if (String::StartsWith(l,"addFacesPoints"))	{
                                        if (!GetBoolValueFromLine(l,params.addFacesPoints)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"compacityWeight"))	{
                                        if (!GetDoubleValueFromLine(l,params.compacityWeight)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"volumeWeight"))	{
                                        if (!GetDoubleValueFromLine(l,params.volumeWeight)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"optionalVRMLSaveFilePath"))	{
                                        if (!GetStringValueFromLine(l,params.optionalVRMLSaveFilePath)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"connectionDistance"))	{
                                        if (!GetDoubleValueFromLine(l,params.connectionDistance)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"targetNTrianglesDecimatedMesh"))	{
                                        if (!GetSizeTValueFromLine(l,params.targetNTrianglesDecimatedMesh)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"displayDebugInfo"))	{
                                        if (!GetBoolValueFromLine(l,params.displayDebugInfo)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"scaleFactor"))	{
                                        if (!GetDoubleValueFromLine(l,params.scaleFactor)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"smallClusterThreshold"))	{
                                        if (!GetDoubleValueFromLine(l,params.smallClusterThreshold)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"heapManagerChunkSize"))	{
                                        if (!GetSizeTValueFromLine(l,params.heapManagerChunkSize)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"decomposeOnlySelectedSubmeshes"))	{
                                        if (!GetIntVectorValueFromLine(l,params.decomposeOnlySelectedSubmeshes)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"keepSubmeshesSeparatedNClusters"))	{
                                        if (!GetIntVectorValueFromLine(l,params.keepSubmeshesSeparatedNClusters)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"keepSubmeshesSeparatedMaxHullVertices"))	{
                                        if (!GetIntVectorValueFromLine(l,params.keepSubmeshesSeparatedMaxHullVertices)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"keepSubmeshesSeparated"))	{
                                        if (!GetBoolValueFromLine(l,params.keepSubmeshesSeparated)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"decomposeACleanCopyOfTheMesh"))	{
                                        if (!GetBoolValueFromLine(l,params.decomposeACleanCopyOfTheMesh)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"decomposeADecimatedCopyOfTheMesh"))	{
                                        if (!GetBoolValueFromLine(l,params.decomposeADecimatedCopyOfTheMesh)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"decimationDistanceInAabbHalfExtentsUnits"))	{
                                        if (!GetFloatValueFromLine(l,params.decimationDistanceInAabbHalfExtentsUnits)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"decimationDistanceUniformInXYZ"))	{
                                        if (!GetBoolValueFromLine(l,params.decimationDistanceUniformInXYZ)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"decomposeACenteredCopyOfTheMesh"))	{
                                        if (!GetBoolValueFromLine(l,params.decomposeACenteredCopyOfTheMesh)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"decomposeATranslatedCopyOfTheMesh"))	{
                                        if (!GetBtVector3ValueFromLine(l,params.decomposeATranslatedCopyOfTheMesh)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"decomposeAScaledCopyOfTheMesh"))	{
                                        if (!GetBtVector3ValueFromLine(l,params.decomposeAScaledCopyOfTheMesh)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"optionalBCSSaveFilePath"))	{
                                        if (!GetStringValueFromLine(l,params.optionalBCSSaveFilePath)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"convexHullsCollisionMargin"))	{
                                        if (!GetFloatValueFromLine(l,params.convexHullsCollisionMargin)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"reduceHullVerticesUsingBtShapeHull"))	{
                                        if (!GetBoolValueFromLine(l,params.reduceHullVerticesUsingBtShapeHull)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"convexHullsEnablePolyhedralContactClipping"))	{
                                        if (!GetBoolValueFromLine(l,params.convexHullsEnablePolyhedralContactClipping)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"shrinkObjectInwardsToCompensateCollisionMargin"))	{
                                        if (!GetBoolValueFromLine(l,params.shrinkObjectInwardsToCompensateCollisionMargin)) errorLines+=line+"\n";
                                        continue;
                                }
                                //endregion
                                else {
                                        errorLines+=line+"\n";
                                        continue;
                                }
                        }
                        else if (String::StartsWith(line,"extraParams."))	{
                                l = line.substr(12);
                                 //region Extra Params
                                if (String::StartsWith(l,"reset()"))	{
                                        *extraParamUseAutoGeneratedSaveNameToSaveShape = *extraParamInvertYZ = *extraParamIgnoreAllParamsAndCreateBvhTriangleMeshShape =
                                        *extraParamIgnoreAllParamsAndCreateGImpaceMeshShape = *extraParamDecomposeBCSInputFileIfShapeIsCompatible = false;
                                        continue;
                                }
                                else if (String::StartsWith(l,"useAutoGeneratedSaveNameToSaveShape"))	{
                                        if (!GetBoolValueFromLine(l,*extraParamUseAutoGeneratedSaveNameToSaveShape)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"invertYZ"))	{
                                        if (!GetBoolValueFromLine(l,*extraParamInvertYZ)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"ignoreAllParamsAndCreateBvhTriangleMeshShape"))	{
                                        if (!GetBoolValueFromLine(l,*extraParamIgnoreAllParamsAndCreateBvhTriangleMeshShape)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"ignoreAllParamsAndCreateGImpaceMeshShape"))	{
                                        if (!GetBoolValueFromLine(l,*extraParamIgnoreAllParamsAndCreateGImpaceMeshShape)) errorLines+=line+"\n";
                                        continue;
                                }
                                else if (String::StartsWith(l,"decomposeBCSInputFileIfShapeIsCompatible"))	{
                                        if (!GetBoolValueFromLine(l,*extraParamDecomposeBCSInputFileIfShapeIsCompatible)) errorLines+=line+"\n";
                                        continue;
                                }                                                      
                                //endregion
                                else {
                                        errorLines+=line+"\n";
                                        continue;
                                }
                        }
                        //endregion
                }
        }
        catch(...)	{
                in.close();
                return false;
        }
        in.close();
        if (errorLines.size()>0) printf("\nThese lines from the file: \"%s\" can't be parsed properly and are ignored:\n\n%s\n\n",paramsFilePath,errorLines.c_str());
        return true;
}

